function [Y Y1 D]=mybptreeinfer(X,emp,F,name,g,D_X,ds)

[E, Nedges] = assignEdgeNums(D_X);
[m n]=size(emp);
nstates=m*ones(1,n);
engine = bptreeEngine(E, nstates,'maximize', 1);
nnodes=length(X);
for i=1:nnodes
   emp0=emp(:,i);  emp0(emp0==0)=ds;
   localEv{i} = emp0;
end

for i=1:nnodes
  for j=i+1:nnodes
    if (D_X(i,j))
       Fem0=F{E(i,j)};  Fem0(Fem0==0)=ds;
       pot{E(i,j)} = Fem0;
    end
  end
end

[belBP, belE, logZ]= bptreeInfer(engine, pot, localEv, 'computeBethe', 0);


d_name=length(name);
for i=1:n
    [c ind(i)]=max(belBP{i});
    if ind(i)<=d_name; Y{i}=name{ind(i)};else Y{i}='gap';end
end
ind1=ind(ind<=d_name);
%ind1=union(ind1,ind1);
D=g(ind1,ind1);
Y1={};
for i=1:n
    c=max(belBP{i});
    ind=find(belBP{i}==c);
    for j=1:length(ind)
        if ind(j)<=d_name; Y1{i,j}=ind(j);else Y1{i,j}=[];end
    end
end