function [X G NAME E D_X]=trans(str1,str2,str3)
% str1 query network text, two nodes at least
% str2 target network text, two nodes at least
% str3 the node feature function text


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    fid=fopen(str1,'r');
    D_X=sparse(2,2); 
    X={};m=1;
    while 1   
        tline=fgetl(fid);
        if ~ischar(tline), break, end
        rem=tline;
        [name,rem] = strtok(rem);
         name1=name;
         while ~isempty(rem)
             [name,rem] = strtok(rem); name2=name;
             if(~isempty(name1) & ~isempty(name2))
                   if isempty(find(strcmp(name1,X))); X{m}=name1;m=m+1;end
                   if isempty(find(strcmp(name2,X))); X{m}=name2;m=m+1;end
                   ig=find(strcmp(name1,X));jg=find(strcmp(name2,X));
                   D_X(ig,jg)=1;
             end
         end
    end
    fclose(fid);
    
    [mD_X nD_X]=size(D_X);
    if(mD_X>nD_X)
       D_X=[D_X zeros(mD_X,mD_X-nD_X)]; 
    elseif(mD_X<nD_X)
       D_X=[D_X;zeros(nD_X-mD_X,nD_X)]; 
    end



%%%%%%%%%%%%%%%%%%%%%%%%%%%

fid=fopen(str2,'r');
G=sparse(2,2);
NAME={};m=1;
while 1
tline=fgetl(fid);
if ~ischar(tline), break, end
a=strfind(tline,' ');
k=length(a);
for i=1:k
    if(i==1)
        str=tline(1:a(1)-1);
        str1_=str;
    else
        str=tline(a(i-1)+1:a(i)-1);
    end
    if isempty(find(strcmp(str,NAME))); NAME{m}=str;m=m+1;end
    ig=find(strcmp(str1_,NAME));
    if(i>=2)
        jg=find(strcmp(str,NAME));
        G(ig,jg)=1;
    end
end
end
fclose(fid);

[mG nG]=size(G);
if(mG>nG)
    G=[G zeros(mG,mG-nG)];
elseif(mG<nG)
    G=[G;zeros(nG-mG,nG)];
end
%%%%%%%%%%%%%%%%%%%%%%%%%
fid=fopen(str3,'r');

E=inf*ones(size(G,1),length(X));%**********
while 1
tline=fgetl(fid);
if ~ischar(tline), break, end
rem=tline;
for i=1:3
   [str,rem] = strtok(rem);
   if isempty(str),  break;  end
   if(i==1)
       je=find(strcmp(str,X));
   elseif(i==2)
       ie=find(strcmp(str,NAME));
   else
       e=str2num(str);
   end
end
E(ie,je)=e;
end
fclose(fid);