function F1=tranf2(D,di,dd,emp,D_X,dc)
% compute the edge feature function 
% output the edge feature function matrixes for edges

D_X2=D_X+D_X';
D_X2(D_X2>1)=1;

    D=1./D.^di;
    [nemp nnodes]=size(emp);
    E=emp(1:(nemp-1),:);
    [m n]=size(D);
    [E0, Nedges] = assignEdgeNums(D_X2);
    for i=1:nnodes
        for j=i+1:nnodes
            if (D_X2(i,j))
                 E1=E(:,i)*ones(1,n);
                 E2=ones(n,1)*E(:,j)';
                if(D_X(i,j)==1 & D_X(j,i)==1)
                    D_1=(E1+E2).*D/2;
                    D1=1./(dd*ones(1,size(D_1,1)));D2=1/(dc);
                    D0=[D_1 D1';D1 D2];
                    F1{E0(i,j)}=max(D0,D0');
                elseif(D_X(i,j)==1 & D_X(j,i)~=1)
                    D_1=(E1+E2).*D/2;
                    D1=1./(dd*ones(1,size(D_1,1)));D2=1/(dc);
                    D0=[D_1 D1';D1 D2];
                    F1{E0(i,j)} = D0;
                elseif(D_X(i,j)~=1 & D_X(j,i)==1)
                    D_1=(E1+E2).*D'/2;
                    D1=1./(dd*ones(1,size(D_1,1)));D2=1/(dc);
                    D0=[D_1 D1';D1 D2];
                    F1{E0(i,j)} = D0;
                end
            end
        end
    end
